"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts = __importStar(require("typescript"));
const typescript_ast_util_1 = require("typescript-ast-util");
/**

# description

assign an undeclared variable to a value

# example

a=1

# attacks
"code": "2304", Cannot find name 'b'.",

TODO: test with jsdoc or a trailing comment
ISSUE : incorrectly suggesting in this case when cursor is on "Alpha" : const foo = new Alpha('hello')
*/
exports.codeFixCreateVariable = {
    name: 'Declare variable',
    config: { variableType: 'const' },
    predicate: (options) => {
        if ((options.containingTarget.kind === ts.SyntaxKind.BinaryExpression ||
            options.containingTarget.parent && options.containingTarget.parent.kind === ts.SyntaxKind.BinaryExpression ||
            options.containingTarget.parent.parent && options.containingTarget.parent.parent.kind === ts.SyntaxKind.BinaryExpression)
            &&
                options.diagnostics.find(d => d.code === 2304 && d.start === options.containingTargetLight.getStart())) {
            return true;
        }
        else {
            options.log(`predicate false because child.kind dont match ${typescript_ast_util_1.getKindName(options.containingTarget.kind)} - ${typescript_ast_util_1.getKindName(options.containingTarget.parent.kind)}`);
            return false;
        }
    },
    description: (options) => `Declare variable "${options.containingTarget.getText()}"`,
    apply: (options) => {
        options.simpleNode.getSourceFile().insertText(options.simpleNode.getStart(), 'const ');
    }
};
//# sourceMappingURL=declareVariable.js.map